
'''
Experimenting with the API of google maps    
'''

from splinter.browser import Browser
import time, sys, os
import glob

''' 
Obtaining the values from the HTML form 
'''

HTML_FILE = 'get_directions.html'
FROM_FIELD = 'from' 
TO_FIELD = 'to'
RESULTS_FIELD = 'textarea'
MODE_FIELD = 'mode'
BUTTON = 'calc'
DUR_DIST = 'dur_dist'
COST = 'cost'
OPTION_CAR = 'DRIVING'
OPTION_BUS = 'TRANSIT'
#OPTION_BICYCLE = 'BICYCLING'
OPTION_WALKING = 'WALKING'


SLEEP_BETWEEN_CALLS = 0.1;


P = ""

def findHomeWorPathForUsers(browser, read_f, write_car_path, write_car_dur_dist, write_transit_path, write_transit_dur_dist, write_walk_path, write_walk_dur_dist):
	'''
	Given the name of the file where home and work location of the users are stored 
	this method would find the path for all the users and store the path in a file.
	''' 
	fr = open(read_f, 'r'); 

	fw_path = open(write_car_path, 'w');
	fw_dur_dist = open(write_car_dur_dist, 'w')

	fw_transit_path = open(write_transit_path, 'w');
	fw_transit_dur_dist = open(write_transit_dur_dist, 'w')

	fw_walk_path = open(write_walk_path, 'w');
	fw_walk_dur_dist = open(write_walk_dur_dist, 'w')

	for index, line in enumerate(open(read_f)):
		perturbation, home, work = [term.strip() for term in line.split("\t")]

                path, dur_dist, cost = ["", "", ""]
                try:
                        path, dur_dist, cost  = getPath(browser, home, work)
                except:
                        pass

                path_return, dur_dist_return, cost_return = ["", "", ""]
                try:
                        path_return, dur_dist_return, cost_return  = getPath(browser, work, home)
                except:
                        pass

		path_by_bus, dur_dist_by_bus, cost_by_bus = ["", "", ""]
		try:
			path_by_bus, dur_dist_by_bus, cost_by_bus = getPath(browser, home, work, OPTION_BUS)
		except:
			pass

		r_path_by_bus, r_dur_dist_by_bus, r_cost_by_bus = ["", "", ""]
		try:
			r_path_by_bus, r_dur_dist_by_bus, r_cost_by_bus = getPath(browser, work, home, OPTION_BUS)
		except:
			pass
		
		path_by_walk, dur_dist_by_walk, cost_by_walk = ["", "", ""]
		try:
                        path_by_walk, dur_dist_by_walk, cost_by_walk = getPath(browser, home, work, OPTION_WALKING)
                except:
                        pass

                r_path_by_walk, r_dur_dist_by_walk, r_cost_by_walk = ["", "", ""]
                try:
                        r_path_by_walk, r_dur_dist_by_walk, r_cost_by_walk = getPath(browser, work, home, OPTION_WALKING)
                except:
                        pass

##		fw_path.write(('%s\t%s\t%s\t%s\t%s\t%s\t%s\n')%(user, path, path_return, path_by_bus, r_path_by_bus, path_by_bicy, r_path_by_bicy))
##		fw_dur_dist.write(('%s\t%s:%s\t%s:%s\t%s:%s\t%s:%s\t%s:%s\t%s:%s\n')%(user, dur_dist, cost, dur_dist_return, cost_return, dur_dist_by_bus, cost_by_bus, r_dur_dist_by_bus, r_cost_by_bus, dur_dist_by_bicy, cost_by_bicy, r_dur_dist_by_bicy, r_cost_by_bicy))  

                fw_path.write(perturbation + "\t" + path + "\t" + path_return + "\n")
                fw_dur_dist.write(perturbation + "\t" + dur_dist + ":" + cost + "\t" + dur_dist_return + ":" + cost_return + "\n")

                fw_transit_path.write(perturbation + "\t" + path_by_bus + "\t" + r_path_by_bus + "\n")
                fw_transit_dur_dist.write(perturbation + "\t" + dur_dist_by_bus + ":" + cost_by_bus + "\t" + r_dur_dist_by_bus + ":" + r_cost_by_bus + "\n")

                fw_walk_path.write(perturbation + "\t" + path_by_walk + "\t" + r_path_by_walk + "\n")
                fw_walk_dur_dist.write(perturbation + "\t" + dur_dist_by_walk + ":" + cost_by_walk + "\t" + r_dur_dist_by_walk + ":" + r_cost_by_walk + "\n")

		print ('%d\tPerturbation: %s\t\thome -> work:%s\twork -> home:%s'%(index, perturbation, cost, cost_return))
		print ('%d\tPerturbation: %s\t\thome -> work:%s\twork -> home:%s by transit'%(index, perturbation, cost_by_bus, r_cost_by_bus))
		print ('%d\tPerturbation: %s\t\thome -> work:%s\twork -> home:%s by walk'%(index, perturbation, cost_by_walk, r_cost_by_walk))


	fw_path.close()
	fw_dur_dist.close()
	fw_transit_path.close()
	fw_transit_dur_dist.close()
	fw_walk_path.close()
	fw_walk_dur_dist.close()

	
def getPath(browser, start, end, option = OPTION_CAR):
	'''
	Given a browser, the beginning and the end, this method would find the lat-lng points in between

	Arguments: 
	browser -- An open browser 
	start   -- The starting point
	end     -- The ending point of the path
	'''

	try:
		browser.fill(FROM_FIELD, start);
		browser.fill(TO_FIELD, end);
		browser.select(MODE_FIELD, option)
		browser.find_by_id(BUTTON).click();

		failures = 0

		while failures < 10:
			path_result = browser.find_by_name(RESULTS_FIELD).value
			duration_distance = browser.find_by_name(DUR_DIST).value
			cost = browser.find_by_name(COST).value    

			if path_result == "":
				failures += 1
				time.sleep(failures*SLEEP_BETWEEN_CALLS);
				browser.find_by_id(BUTTON).click();
				continue;

			browser.fill(RESULTS_FIELD, ''); browser.fill(DUR_DIST, ''); browser.fill(COST, '');
			return path_result.strip().replace('\n', '|'), duration_distance, cost
	except Error, e:
		print e


if __name__ == '__main__':
	if not os.path.exists(HTML_FILE):
		print "ERROR !!!\nThe .hmtl file required to communicate with Google maps is missing"
	url = ('file:///%s')%(os.path.abspath(HTML_FILE)) 

	# Prepare browser   
	browser = Browser();
	browser.visit(url);

	# Test
	#print getPath(browser, 'Barcelona, Spain', 'Madrid, Spain');

        files = glob.glob("../16_perturbations/*")
        for index, afile in enumerate(files):
                print index, afile
                 # Find the path for each user in "home_work_clusters"
                store_car_path_info = "../17_google_route/" + os.path.basename(afile).split(".")[0] + '_path_by_car.txt'
                store_car_dd_info = "../17_google_route/" + os.path.basename(afile).split(".")[0] + '_dur_dist_by_car.txt'      

                store_transit_path_info = "../17_google_route/" + os.path.basename(afile).split(".")[0] + '_path_by_transit.txt'
                store_transit_dd_info = "../17_google_route/" + os.path.basename(afile).split(".")[0] + '_dur_dist_by_transit.txt'      

                store_walk_path_info = "../17_google_route/" + os.path.basename(afile).split(".")[0] + '_path_by_walk.txt'
                store_walk_dd_info = "../17_google_route/" + os.path.basename(afile).split(".")[0] + '_dur_dist_by_walk.txt'      


                findHomeWorPathForUsers(browser, afile, store_car_path_info, store_car_dd_info, store_transit_path_info, store_transit_dd_info, store_walk_path_info, store_walk_dd_info)
                
        browser.quit()
