package es.tid.haewoon.cdr.perturbation;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.ParseException;
import java.util.Calendar;

import org.apache.log4j.Logger;

import es.tid.haewoon.cdr.filter.CDRFilter;
import es.tid.haewoon.cdr.filter.MonthFilter;
import es.tid.haewoon.cdr.util.CDR;
import es.tid.haewoon.cdr.util.Constants;

public class SplitTrainAndTest {
    Logger logger = Logger.getLogger(SplitTrainAndTest.class);
    CDRFilter sepFilter = new MonthFilter(Calendar.SEPTEMBER);
    CDRFilter octFilter = new MonthFilter(Calendar.OCTOBER);
    CDRFilter novFilter = new MonthFilter(Calendar.NOVEMBER);

    public static void main(String[] args) throws IOException, ParseException {
        (new SplitTrainAndTest()).run(Constants.RESULT_PATH + File.separator + "19_train_and_test_route");
    }

    private void run(String targetDirectory) throws IOException, ParseException {
        boolean success = (new File(targetDirectory)).mkdir();
        if (success) {
            logger.info("A directory [" + targetDirectory + "] is created");
        }

        String trainingDirectory = targetDirectory + File.separator + "training";
        String testDirectory = targetDirectory + File.separator + "test";
        success = (new File(trainingDirectory)).mkdir();
        success = (new File(testDirectory)).mkdir();

        BufferedReader br = new BufferedReader(new FileReader(
                Constants.RESULT_PATH + File.separator + "11_home_work_lat_long" + File.separator + "home_2_work"));
        String line;

        while ((line = br.readLine()) != null) {
            String[] tokens = line.split("\t");

            String telephone = tokens[0];
            logger.debug(telephone);
            try {
                BufferedReader callR = new BufferedReader(new FileReader(
                        Constants.FILTERED_PATH + File.separator + "6_3_focused_commuting_hours" + File.separator + telephone));
                BufferedWriter trainBW = new BufferedWriter(new FileWriter(trainingDirectory + File.separator + telephone));
                BufferedWriter testBW = new BufferedWriter(new FileWriter(testDirectory + File.separator + telephone));

                int record = 0;
                while ((line = callR.readLine()) != null) {
                    CDR cdr = new CDR(line);
                    if (record % 3 == 0) {
                        testBW.write(line.trim());
                        testBW.newLine();
                    } else {
                        trainBW.write(line.trim());
                        trainBW.newLine();             
                    }
                    record += 1;
                    //                    if (sepFilter.filter(cdr) || octFilter.filter(cdr)) {
                    //                        trainBW.write(line.trim());
                    //                        trainBW.newLine();
                    //                    } else {
                    //                        testBW.write(line.trim());
                    //                        testBW.newLine();
                    //                    }

                }
                trainBW.close();
                testBW.close();
            } catch (FileNotFoundException fnfe) {
                logger.error(telephone, fnfe);
            }
        }
    }
}
